Attribute VB_Name = "modImageKit"
Option Explicit
Public Sub LoadFile(ByVal sFileName As String, ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkFile As IkFile)
10:  On Error GoTo Error_Handler
20:  Dim ret As Boolean
30:  If sFileName = vbNullString Then Exit Sub
40:  If oIkDisp.ImgHandle <> 0 Then
50:    oIkCommon.ImgHandle = oIkDisp.ImgHandle
60:    oIkCommon.FreeMemory
70:    oIkDisp.ImgHandle = 0
80:  End If
90:  oIkFile.FileName = sFileName
100:  On Error GoTo Error_Load_File
110:  oIkFile.LoadFile (ikLoad)
120:  On Error GoTo Error_Handler
130:  oIkCommon.ImgHandle = oIkFile.ImgHandle
140:  ret = oIkCommon.GetImageType()
150:  If ret = False Then Exit Sub
160:  If oIkCommon.ImageKind <> ikRasterImage Then
170:    oIkCommon.FreeMemory
180:    oIkDisp.ImgHandle = 0
190:    Exit Sub
200:  End If
210:  oIkDisp.ImgHandle = oIkFile.ImgHandle 'Pass the image handle to the display control
220:  oIkDisp.Display (ikScale)             'Display the image
230:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:LoadFile", Erl
240:  Resume Next
Error_Load_File:
250:  MsgBox "Error loading image file '" & oIkFile.FileName & "'.", vbCritical, sAppName
End Sub
Public Sub LoadImage(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkFile As IkFile)
260:  On Error GoTo Error_Handler
270:  Dim ret As Boolean
  If oIkFile.OpenFileDlg = False Then Exit Sub 'Display the Open File dialog to select an image
280:  If oIkDisp.ImgHandle <> 0 Then
290:    oIkCommon.ImgHandle = oIkDisp.ImgHandle
300:    oIkCommon.FreeMemory
310:    oIkDisp.ImgHandle = 0
320:  End If
330:  oIkFile.LoadFile (ikLoad)
340:  oIkCommon.ImgHandle = oIkFile.ImgHandle
350:  ret = oIkCommon.GetImageType()
360:  If ret = False Then Exit Sub
370:  If oIkCommon.ImageKind <> ikRasterImage Then
380:    oIkCommon.FreeMemory
390:    oIkDisp.ImgHandle = 0
400:    Exit Sub
410:  End If
420:  oIkDisp.ImgHandle = oIkFile.ImgHandle 'Pass the image handle to the display control
430:  oIkDisp.Display (ikScale)             'Display the image
440:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:LoadImage", Erl
450:  Resume Next
End Sub
Public Sub ReloadImage(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkFile As IkFile)
460:  On Error GoTo Error_Handler
470:  Dim ret As Boolean
480:  If oIkDisp.ImgHandle <> 0 Then
490:    oIkCommon.ImgHandle = oIkDisp.ImgHandle
500:    oIkCommon.FreeMemory
510:    oIkDisp.ImgHandle = 0
520:  Else
530:    Exit Sub
540:  End If
550:  oIkFile.LoadFile (ikLoad)
560:  oIkCommon.ImgHandle = oIkFile.ImgHandle
570:  ret = oIkCommon.GetImageType()
580:  If ret = False Then Exit Sub
590:  If oIkCommon.ImageKind <> ikRasterImage Then
600:    oIkCommon.FreeMemory
610:    oIkDisp.ImgHandle = 0
620:    Exit Sub
630:  End If
640:  oIkDisp.ImgHandle = oIkFile.ImgHandle 'Pass the image handle to the display control
650:  oIkDisp.Display (ikScale)             'Display the image
660:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:ReloadImage", Erl
670:  Resume Next
End Sub
Public Sub SetBrightness(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByVal iBrightness As Integer)
680:  On Error GoTo Error_Handler
690:  Dim ret As Boolean
700:  oIkEffect.SelectMode = 1
710:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
720:  On Error Resume Next
730:  ret = oIkEffect.RGBLevel(0, 0, 0, iBrightness, iBrightness, iBrightness)
740:  On Error GoTo Error_Handler
750:  If ret = False Then Exit Sub
760:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
770:  oIkCommon.FreeMemory
780:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
790:  oIkDisp.Refresh
800:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:SetBrightness", Erl
810:  Resume Next
End Sub
Public Sub SetContrast(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByVal iContrast As Integer)
820:  On Error GoTo Error_Handler
830:  Dim i           As Long
840:  Dim spx(0 To 4) As Long
850:  Dim spy(0 To 4) As Long
860:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  spx(0) = 0: spy(0) = 0
  spx(1) = 64: spy(1) = spx(1) - iContrast
  spx(2) = 128: spy(2) = 128
  spx(3) = 192: spy(3) = spx(3) + iContrast
  spx(4) = 255: spy(4) = 255
870:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
880:  oIkEffect.SelectMode = ikEffectAll
890:  On Error Resume Next
900:  i = oIkEffect.RGBSpline(0, 0, 0, spx(0), spy(0), 5, 1, 1, 1)
910:  On Error GoTo Error_Handler
920:  If i = False Then Exit Sub
930:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
940:  oIkCommon.FreeMemory
950:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
960:  oIkDisp.Refresh
970:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:SetContrast", Erl
980:  Resume Next
End Sub
Public Sub Mirror1(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
990:  On Error GoTo Error_Handler
1000:  Dim ret As Boolean
1010:  If oIkDisp.ImgHandle = 0 Then Exit Sub
1020:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1030:  oIkEffect.InMskHandle = 0
1040:  ret = oIkEffect.Rotation(0, True, False, False, 255, 255, 255, False)
1050:  If ret = False Then Exit Sub
1060:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1070:  oIkCommon.FreeMemory
1080:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1090:  oIkDisp.Refresh
1100:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Mirror1", Erl
1110:  Resume Next
End Sub
Public Sub Mirror2(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1120:  On Error GoTo Error_Handler
1130:  Dim ret As Boolean
1140:  If oIkDisp.ImgHandle = 0 Then Exit Sub
1150:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1160:  oIkEffect.InMskHandle = 0
1170:  ret = oIkEffect.Rotation(0, False, True, False, 255, 255, 255, False)
1180:  If ret = False Then Exit Sub
1190:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1200:  oIkCommon.FreeMemory
1210:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1220:  oIkDisp.Refresh
1230:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Mirror2", Erl
1240:  Resume Next
End Sub
Public Sub Inverse(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1250:  On Error GoTo Error_Handler
1260:  Dim i           As Long
1270:  Dim spx(0 To 4) As Long
1280:  Dim spy(0 To 4) As Long
1290:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  spx(0) = 0: spy(0) = 255
  spx(1) = 64: spy(1) = 192
  spx(2) = 128: spy(2) = 128
  spx(3) = 192: spy(3) = 64
  spx(4) = 255: spy(4) = 0
1300:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1310:  oIkEffect.SelectMode = ikEffectAll
1320:  i = oIkEffect.RGBSpline(0, 0, 0, spx(0), spy(0), 5, 1, 1, 1)
1330:  If i = False Then Exit Sub
1340:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1350:  oIkCommon.FreeMemory
1360:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1370:  oIkDisp.Refresh
1380:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Inverse", Erl
1390:  Resume Next
End Sub
Public Sub RedEye(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1400:  On Error GoTo Error_Handler
1410:  Dim ret       As Boolean
1420:  Dim X(0 To 3) As Long
1430:  Dim Y(0 To 3) As Long
1440:  If oIkDisp.ImgHandle = 0 Then Exit Sub
1450:  oIkEffect.RectTop = oIkDisp.RectTop
1460:  oIkEffect.RectLeft = oIkDisp.RectLeft
1470:  oIkEffect.RectBottom = oIkDisp.RectBottom
1480:  oIkEffect.RectRight = oIkDisp.RectRight
1490:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1500:  oIkEffect.InOut = ikInside
1510:  oIkEffect.SelectMode = ikEffectEllipse
1520:  If oIkEffect.RectRight And oIkEffect.RectBottom = 0 Then Exit Sub
1530:  ret = oIkEffect.RedEyeRemoval(X(0), Y(0), 4, 95, 90, 120, 50)
1540:  If ret = False Then Exit Sub
1550:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1560:  oIkCommon.FreeMemory
1570:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1580:  oIkDisp.Refresh
1590:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:RedEye", Erl
1600:  Resume Next
End Sub
Public Sub Sepia(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1610:  On Error GoTo Error_Handler
1620:  Dim ret As Long
1630:  If oIkDisp.ImgHandle = 0 Then Exit Sub
1640:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1650:  ret = oIkEffect.ConvertColor(80, False, False, 128)
1660:  If ret <> 0 Then
1670:    oIkCommon.ImgHandle = oIkEffect.InImgHandle
1680:    oIkCommon.FreeMemory
1690:    oIkEffect.InImgHandle = oIkEffect.OutImgHandle
1700:  Else 'Grayscale, scanned image
1710:    oIkEffect.InImgHandle = oIkDisp.ImgHandle
1720:  End If
1730:  ret = oIkEffect.ConvertColor(24, False, False, 128)
1740:  If ret <> 0 Then
1750:    oIkCommon.ImgHandle = oIkEffect.InImgHandle
1760:    oIkCommon.FreeMemory
1770:  End If
1780:  oIkCommon.ImgHandle = oIkEffect.OutImgHandle
1790:  oIkEffect.InImgHandle = oIkCommon.CopyImage
1800:  oIkEffect.SelectMode = 1
1810:  ret = oIkEffect.RGBLevel(0, 0, 0, 40, -20, -80)
1820:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1830:  oIkCommon.FreeMemory
1840:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1850:  oIkDisp.Display (ikScale)
1860:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Sepia", Erl
1870:  Resume Next
End Sub
Public Sub Gray(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1880:  On Error GoTo Error_Handler
1890:  Dim ret       As Boolean
1900:  Dim X(0 To 3) As Long
1910:  Dim Y(0 To 3) As Long
1920:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  X(0) = oIkDisp.RectLeft: Y(0) = oIkDisp.RectTop
  X(1) = oIkDisp.RectRight: Y(1) = oIkDisp.RectTop
  X(2) = oIkDisp.RectRight: Y(2) = oIkDisp.RectBottom
  X(3) = oIkDisp.RectLeft: Y(3) = oIkDisp.RectBottom
1930:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1940:  oIkEffect.InMskHandle = 0
1950:  oIkEffect.InOut = ikInside
1960:    oIkEffect.SelectMode = ikEffectAll
1970:  ret = oIkEffect.Chroma(X(0), Y(0), 4, -100)
1980:  If ret = False Then Exit Sub
1990:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2000:  oIkCommon.FreeMemory
2010:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2020:  oIkDisp.Refresh
2030:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Gray", Erl
2040:  Resume Next
End Sub
Public Sub Blur(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2050:  On Error GoTo Error_Handler
2060:  Dim ret       As Boolean
2070:  Dim X(0 To 3) As Long
2080:  Dim Y(0 To 3) As Long
2090:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  X(0) = oIkDisp.RectLeft: Y(0) = oIkDisp.RectTop
  X(1) = oIkDisp.RectRight: Y(1) = oIkDisp.RectTop
  X(2) = oIkDisp.RectRight: Y(2) = oIkDisp.RectBottom
  X(3) = oIkDisp.RectLeft: Y(3) = oIkDisp.RectBottom
2100:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2110:  oIkEffect.InMskHandle = 0
2120:  oIkEffect.InOut = ikInside
2130:  oIkEffect.SelectMode = ikEffectPolygon
2140:  If oIkDisp.RectLeft = 0 And oIkDisp.RectTop = 0 And oIkDisp.RectRight = 0 And oIkDisp.RectBottom = 0 Then oIkEffect.SelectMode = ikEffectAll
2150:  ret = oIkEffect.Blur(X(0), Y(0), 4, 5)
2160:  If ret = False Then Exit Sub
2170:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2180:  oIkCommon.FreeMemory
2190:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2200:  oIkDisp.Refresh
2210:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Blur", Erl
2220:  Resume Next
End Sub
Public Sub MotionBlur(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2230:  On Error GoTo Error_Handler
2240:  Dim ret       As Boolean
2250:  Dim X(0 To 3) As Long
2260:  Dim Y(0 To 3) As Long
2270:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  X(0) = oIkDisp.RectLeft: Y(0) = oIkDisp.RectTop
  X(1) = oIkDisp.RectRight: Y(1) = oIkDisp.RectTop
  X(2) = oIkDisp.RectRight: Y(2) = oIkDisp.RectBottom
  X(3) = oIkDisp.RectLeft: Y(3) = oIkDisp.RectBottom
2280:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2290:  oIkEffect.InMskHandle = 0
2300:  oIkEffect.InOut = ikInside
2310:  oIkEffect.SelectMode = ikEffectPolygon
2320:  If oIkDisp.RectLeft = 0 And oIkDisp.RectTop = 0 And oIkDisp.RectRight = 0 And oIkDisp.RectBottom = 0 Then oIkEffect.SelectMode = ikEffectAll
2330:  ret = oIkEffect.MotionBlur(X(0), Y(0), 4, 2, 10, 20)
2340:  If ret = False Then Exit Sub
2350:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2360:  oIkCommon.FreeMemory
2370:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2380:  oIkDisp.Refresh
2390:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:MotionBlur", Erl
2400:  Resume Next
End Sub
Public Sub Waves(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2410:  On Error GoTo Error_Handler
2420:  Dim ret       As Boolean
2430:  Dim X(0 To 3) As Long
2440:  Dim Y(0 To 3) As Long
2450:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  X(0) = oIkDisp.RectLeft: Y(0) = oIkDisp.RectTop
  X(1) = oIkDisp.RectRight: Y(1) = oIkDisp.RectTop
  X(2) = oIkDisp.RectRight: Y(2) = oIkDisp.RectBottom
  X(3) = oIkDisp.RectLeft: Y(3) = oIkDisp.RectBottom
2460:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2470:  oIkEffect.InMskHandle = 0
2480:  oIkEffect.InOut = ikInside
2490:  oIkEffect.SelectMode = ikEffectPolygon
2500:  If oIkDisp.RectLeft = 0 And oIkDisp.RectTop = 0 And oIkDisp.RectRight = 0 And oIkDisp.RectBottom = 0 Then oIkEffect.SelectMode = ikEffectAll
2510:  ret = oIkEffect.Waves(X(0), Y(0), 4, 0, 0, 100, 10, 0.5, 1, 0, 0, 0)
2520:  If ret = False Then Exit Sub
2530:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2540:  oIkCommon.FreeMemory
2550:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2560:  oIkDisp.Refresh
2570:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Waves", Erl
2580:  Resume Next
End Sub
Public Sub Ripple(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2590:  On Error GoTo Error_Handler
2600:  Dim ret       As Boolean
2610:  Dim X(0 To 3) As Long
2620:  Dim Y(0 To 3) As Long
2630:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  X(0) = oIkDisp.RectLeft: Y(0) = oIkDisp.RectTop
  X(1) = oIkDisp.RectRight: Y(1) = oIkDisp.RectTop
  X(2) = oIkDisp.RectRight: Y(2) = oIkDisp.RectBottom
  X(3) = oIkDisp.RectLeft: Y(3) = oIkDisp.RectBottom
2640:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2650:  oIkEffect.InMskHandle = 0
2660:  oIkEffect.InOut = ikInside
2670:  oIkEffect.SelectMode = ikEffectPolygon
2680:  If oIkDisp.RectLeft = 0 And oIkDisp.RectTop = 0 And oIkDisp.RectRight = 0 And oIkDisp.RectBottom = 0 Then oIkEffect.SelectMode = ikEffectAll
2690:  ret = oIkEffect.Ripple(X(0), Y(0), 4, 20, 10, 0.5, False, False, 0, 0, 0)
2700:  If ret = False Then Exit Sub
2710:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2720:  oIkCommon.FreeMemory
2730:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2740:  oIkDisp.Refresh
2750:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Ripple", Erl
2760:  Resume Next
End Sub
Public Sub Canvas(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2770:  On Error GoTo Error_Handler
2780:  Dim ret       As Boolean
2790:  Dim X(0 To 3) As Long
2800:  Dim Y(0 To 3) As Long
2810:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  X(0) = oIkDisp.RectLeft: Y(0) = oIkDisp.RectTop
  X(1) = oIkDisp.RectRight: Y(1) = oIkDisp.RectTop
  X(2) = oIkDisp.RectRight: Y(2) = oIkDisp.RectBottom
  X(3) = oIkDisp.RectLeft: Y(3) = oIkDisp.RectBottom
2820:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2830:  oIkEffect.InMskHandle = 0
2840:  oIkEffect.InOut = ikInside
2850:  oIkEffect.SelectMode = ikEffectPolygon
2860:  If oIkDisp.RectLeft = 0 And oIkDisp.RectTop = 0 And oIkDisp.RectRight = 0 And oIkDisp.RectBottom = 0 Then oIkEffect.SelectMode = ikEffectAll
2870:  ret = oIkEffect.Canvas(X(0), Y(0), 4, 1, 10)
2880:  If ret = False Then Exit Sub
2890:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2900:  oIkCommon.FreeMemory
2910:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2920:  oIkDisp.Refresh
2930:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Canvas", Erl
2940:  Resume Next
End Sub
Public Sub Rotate1(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2950:  On Error GoTo Error_Handler
2960:  Dim ret As Boolean
2970:  If oIkDisp.ImgHandle = 0 Then Exit Sub
2980:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2990:  oIkEffect.InMskHandle = 0
3000:  ret = oIkEffect.Rotation(-90 * 100, False, False, False, 255, 255, 255, False)
3010:  If ret = False Then Exit Sub
3020:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
3030:  oIkCommon.FreeMemory
3040:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
3050:  oIkDisp.Refresh
3060:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Rotate1", Erl
3070:  Resume Next
End Sub
Public Sub Rotate2(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
3080:  On Error GoTo Error_Handler
3090:  Dim ret As Boolean
3100:  If oIkDisp.ImgHandle = 0 Then Exit Sub
3110:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
3120:  oIkEffect.InMskHandle = 0
3130:  ret = oIkEffect.Rotation(90 * 100, False, False, False, 255, 255, 255, False)
3140:  If ret = False Then Exit Sub
3150:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
3160:  oIkCommon.FreeMemory
3170:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
3180:  oIkDisp.Refresh
3190:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Rotate2", Erl
3200:  Resume Next
End Sub
Public Sub Rotate(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByVal fDegrees As Double, ByVal iR As Integer, ByVal iG As Integer, ByVal iB As Integer)
3210:  On Error GoTo Error_Handler
3220:  Dim ret As Boolean
3230:  If oIkDisp.ImgHandle = 0 Then Exit Sub
3240:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
3250:  oIkEffect.InMskHandle = 0
3260:  ret = oIkEffect.Rotation(fDegrees * 100, False, False, True, iR, iG, iB, False)
3270:  If ret = False Then Exit Sub
3280:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
3290:  oIkCommon.FreeMemory
3300:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
3310:  oIkDisp.Refresh
3320:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Rotate", Erl
3330:  Resume Next
End Sub
Public Sub Resize(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByVal lWidthPixels As Long, ByVal lHeightPixels As Long)
3340:  On Error GoTo Error_Handler
3350:  Dim ret As Boolean
3360:  If oIkDisp.ImgHandle = 0 Then Exit Sub
3370:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
3380:  oIkEffect.InMskHandle = 0
3390:  ret = oIkEffect.Resize(lWidthPixels, lHeightPixels, True)
3400:  If ret = False Then Exit Sub
3410:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
3420:  oIkCommon.FreeMemory
3430:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
3440:  oIkDisp.Refresh
3450:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Resize", Erl
3460:  Resume Next
End Sub
Public Sub Crop(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
3470:  On Error GoTo Error_Handler
3480:  Dim ret As Boolean
3490:  If oIkDisp.ImgHandle = 0 Then Exit Sub
3500:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
3510:  oIkEffect.InMskHandle = 0
3520:  oIkEffect.RectLeft = oIkDisp.RectLeft
3530:  oIkEffect.RectTop = oIkDisp.RectTop
3540:  oIkEffect.RectRight = oIkDisp.RectRight
3550:  oIkEffect.RectBottom = oIkDisp.RectBottom
3560:  On Error Resume Next
3570:  ret = oIkEffect.CutRectImage
3580:  On Error GoTo Error_Handler
3590:  If ret = False Then Exit Sub
3600:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
3610:  oIkCommon.FreeMemory
3620:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
3630:  oIkDisp.Refresh
3640:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Crop", Erl
3650:  Resume Next
End Sub
Public Sub Ellipse(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
3660:  On Error GoTo Error_Handler
3670:  Dim ret As Boolean
3680:  If oIkDisp.ImgHandle = 0 Then Exit Sub
3690:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
3700:  oIkEffect.InMskHandle = 0
3710:  oIkEffect.InOut = ikInside
3720:  oIkEffect.SelectMode = ikEffectEllipse
3730:  oIkEffect.RectBottom = oIkDisp.RectBottom
3740:  oIkEffect.RectLeft = oIkDisp.RectLeft
3750:  oIkEffect.RectRight = oIkDisp.RectRight
3760:  oIkEffect.RectTop = oIkDisp.RectTop
3770:  ret = oIkEffect.SelectImage(0, 0, 0, 255, 255, 255)
3780:  If ret = False Then Exit Sub
3790:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
3800:  oIkCommon.FreeMemory
3810:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
3820:  oIkDisp.Refresh
3830:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Ellipse", Erl
3840:  Resume Next
End Sub
Public Sub Polygon(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByRef Ix() As Long, ByRef Iy() As Long, ByVal Points As Long)
3850:  On Error GoTo Error_Handler
3860:  Dim ret As Boolean
3870:  If oIkDisp.ImgHandle = 0 Then Exit Sub
3880:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
3890:  oIkEffect.InMskHandle = 0
3900:  oIkEffect.InOut = ikInside
3910:  oIkEffect.SelectMode = ikEffectPolygon
3920:  oIkEffect.RectBottom = oIkDisp.RectBottom
3930:  oIkEffect.RectLeft = oIkDisp.RectLeft
3940:  oIkEffect.RectRight = oIkDisp.RectRight
3950:  oIkEffect.RectTop = oIkDisp.RectTop
3960:  ret = oIkEffect.SelectImage(Ix(0), Iy(0), Points, 255, 255, 255)
3970:  If ret = False Then Exit Sub
3980:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
3990:  oIkCommon.FreeMemory
4000:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
4010:  oIkDisp.Refresh
4020:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Polygon", Erl
4030:  Resume Next
End Sub
Public Sub SaveAsJPEG(ByVal sFileName As String, ByVal iQuality As Integer, ByRef oIkCommon As IkCommon, ByRef oIkFile As IkFile, ByRef oIkDisp As IkDisp)
4040:  On Error GoTo Error_Handler
4050:  oIkCommon.ImgHandle = oIkDisp.ImgHandle
4060:  oIkCommon.GetImageType
4070:  oIkFile.ImgHandle = oIkCommon.ImgHandle
4080:  oIkFile.FileName = sFileName
4090:  oIkFile.Comment = vbNullString
4100:  oIkFile.JpegQuality = iQuality
  oIkFile.JpegSubsamp = 0 '0 => 4:1:1 / 1 => 4:2:2 / 2 => 4:4:4
4110:  On Error GoTo Error_Save_JPEG
4120:  oIkFile.SaveFile (ikSaveJPEG)
4130:  On Error GoTo Error_Handler
4140:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:SaveAsJPEG", Erl
4150:  Resume Next
Error_Save_JPEG:
4160:  MsgBox "Error saving JPEG file '" & oIkFile.FileName & "'.", vbCritical, sAppName
End Sub
Public Sub SaveAsGIF(ByVal sFileName As String, ByRef oIkCommon As IkCommon, ByRef oIkFile As IkFile, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
4170:  On Error GoTo Error_Handler
4180:  Dim ret As Boolean
4190:  If oIkDisp.ImgHandle = 0 Then Exit Sub
4200:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
4210:  oIkEffect.InMskHandle = 0
4220:  ret = oIkEffect.ConvertColor(8, False, False, 128)
4230:  If ret = False Then Exit Sub
4240:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
4250:  oIkCommon.FreeMemory
4260:  oIkCommon.ImgHandle = oIkEffect.OutImgHandle
4270:  oIkCommon.GetImageType
4280:  oIkFile.ImgHandle = oIkCommon.ImgHandle
4290:  oIkFile.FileName = sFileName
4300:  oIkFile.PalRed = 255
4310:  oIkFile.PalGreen = 255
4320:  oIkFile.PalBlue = 255
4330:  oIkFile.Transparent = True
4340:  On Error GoTo Error_Save_GIF
4350:  oIkFile.SaveFile (ikSaveGIF)
4360:  On Error GoTo Error_Handler
4370:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:SaveAsGIF", Erl
4380:  Resume Next
Error_Save_GIF:
4390:  MsgBox "Error saving GIF file '" & oIkFile.FileName & "'.", vbCritical, sAppName
End Sub
